#include "testApp.h"
#include "particle.h"

#include "ofMain.h"

// comparison routine for sort...
bool comparisonFunction(  particle * a, particle * b ) { 
	return a->pos.x < b->pos.x; 
}              
      

//--------------------------------------------------------------
void testApp::setup(){
//	ofSetFrameRate(50);
	for (int i = 0; i < 50; i++){
		for (int j = 0 ; j<30; j++) {

			
			ofPoint temp;
			int w = ofGetWidth()/45;
			int h= ofGetHeight()/30;
			temp.set(10+i*w, 10+j*h);
			particle * p = new particle();

			p->setInitialCondition(temp.x,temp.y,0,0);
			myParticles.push_back(p);
			initPos.push_back(temp);

		}
	}
	
	//declare objects
	for (int i = 0; i<10; i++) {
		particle * p = new particle();

		ofPoint temp;
		temp.set(0, ofRandom(0, ofGetHeight()));			
		p->setInitialCondition(temp.x,temp.y,0,0);
		movingParticles.push_back(p);		
	}
	
	VF.setupField(60,40,ofGetWidth(), ofGetHeight());
	VF.randomizeField(3.0);
	
	picture.loadImage("ink.png");

	//ofSetCircleResolution();
	ofSetRectMode(OF_RECTMODE_CENTER);
}

//--------------------------------------------------------------
void testApp::update(){
	
	VF.fadeField(0.99);
	
	//cout << ofGetFrameRate() << endl;
	
	// sort all the particle
	sort( myParticles.begin(), myParticles.end(), comparisonFunction );               // sort them!
	sort( movingParticles.begin(), movingParticles.end(), comparisonFunction );               // sort them!

	
	
	//POINTS
	
	ofBackground(0,0,0); //Grey background, NY style
	
    for (int i = 0; i < myParticles.size(); i++){
        myParticles[i]->resetForce();
		//check against another particles from same family
		for (int j = i-1; j >= 0; j--){
			if ( fabs(myParticles[j]->pos.x - myParticles[i]->pos.x) >  10) break;
			
			for (int ii =0; ii<movingParticles.size(); ii++) {
				myParticles[i]->addRepulsionForce(*movingParticles[ii], 100, 0.5f);

				//myParticles[i]->addAttractionForce(*movingParticles[ii], 200, 2.0f);
			}
			myParticles[i]->addRepulsionForce( *myParticles[j],50,0.3f);
		}
		
		//myParticles[i]->addRepulsionForce(myParticles[i]->pos.x, myParticles[i]->pos.x, 100, 6.0f);			
		myParticles[i]->pos.x--;

		//myParticles[i]->addAttractionForce( mouseX,mouseY,150,3.7);
		myParticles[i]->addDampingForce();
		myParticles[i]->invertWalls();
        myParticles[i]->update();
		}
	
	
	
	
	//OBJECTS
	
	for (int i = 0; i < movingParticles.size(); i++){
        movingParticles[i]->resetForce();
		ofxVec2f frc;
		frc = VF.getForceFromPos(movingParticles[i]->pos.x, movingParticles[i]->pos.y);
		movingParticles[i]->addForce(frc.x, frc.y);
    }
	
	for (int i = 0; i < movingParticles.size(); i++){
		for (int j = i-1; j >= 0; j--){
			if ( fabs(movingParticles[j]->pos.x - movingParticles[i]->pos.x) >  10) break;
			
			for (int ii =0; ii<myParticles.size(); ii++) {
				movingParticles[i]->addRepulsionForce(*myParticles[ii], 100, 0.5f);
				
				//myParticles[i]->addAttractionForce(*movingParticles[ii], 200, 2.0f);
			}
			movingParticles[i]->addRepulsionForce( *movingParticles[j],100,0.5f);
			movingParticles[i]->addAttractionForce( *movingParticles[j],200,0.03f);

		}
    }
	
	
    for (int i = 0; i < movingParticles.size(); i++){
		movingParticles[i]->pos.x++;
		movingParticles[i]->pos.y=movingParticles[i]->pos.y+2*cos(ofGetElapsedTimef()) ;		
		//movingParticles[i]->addRepulsionForce(movingParticles[i]->pos.x, movingParticles[i]->pos.x, 100, 1.0f);			
		movingParticles[i]->invertWalls();
		
		movingParticles[i]->addAttractionForce( mouseX,mouseY,100,0.7);
		 
	
			
		movingParticles[i]->addDampingForce();

        movingParticles[i]->update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	ofEnableAlphaBlending();
	ofSetColor(255,255,255,255);
	// then draw:
	
	for (int i = 0; i < myParticles.size(); i++){
		int r = ofMap(myParticles[i]->pos.x, 0, ofGetWidth(), 70, 255);
		int g = ofMap(myParticles[i]->pos.y, 0, ofGetHeight(), 70, 255);
		int b = ofMap(myParticles[i]->vel.x, 0,10, 70, 255);
		
		
		ofSetColor(r,g,b, 255);
		
		ofxVec2f frc;
		frc = VF.getForceFromPos(myParticles[i]->pos.x, myParticles[i]->pos.y);			
		myParticles[i]->draw(&picture);
	}
	
	
	for (int i = 0; i < movingParticles.size(); i++){
		movingParticles[i]->draw2();
		VF.addOutwardCircle(movingParticles[i]->pos.x, movingParticles[i]->pos.y, 100, 0.2f);
		VF.addClockwiseCircle(movingParticles[i]->pos.x, movingParticles[i]->pos.y, 100, 0.2f);

	
	}

	ofDisableAlphaBlending();
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){
   
}
//--------------------------------------------------------------
void testApp::keyReleased  (int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
}
